#include "applet-generic-application-button.h"
#include "applet-menu.h"
#include "cdos-app.h"
#include "applet-contextmenu.h"
#include "applet-application-contextmenu-item.h"
#include "st.h"
#include "cdos-app-favorites.h"
#include "cdos-monkey-plugin.h"
#include "applet-util.h"
#include "gio/gio.h"

/*可以打开应用程序并且包含右键菜单的按钮*/

G_DEFINE_TYPE(AppletGenericApplicationButton, applet_generic_application_button, APPLET_TYPE_BUTTON);

/*#define APPLET_GENERIC_APPLICATION_BUTTON_GET_PRIVATE(obj) \
(G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_GENERIC_APPLICATION_BUTTON, AppletGenericApplicationButtonPrivate))
*/
struct _AppletGenericApplicationButtonPrivate {

};

enum {
    PROP_0
};

enum
{
    LAST_SIGNAL
};


static void
applet_generic_application_button_finalize(GObject *object)
{
 //    AppletGenericApplicationButtonPrivate *priv = APPLET_GENERIC_APPLICATION_BUTTON(object)->priv;

     /*调用父类的finalize()方法*/
     G_OBJECT_CLASS(applet_generic_application_button_parent_class)->finalize(object);
}

static void
applet_generic_application_button_set_property(GObject * gobject,
                guint prop_id,
                const GValue * value, GParamSpec * pspec)
{
    AppletGenericApplicationButton *obj = APPLET_GENERIC_APPLICATION_BUTTON(gobject);

    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_generic_application_button_get_property(GObject * gobject,
                guint prop_id, GValue * value, GParamSpec * pspec)
{
   // AppletGenericApplicationButtonPrivate *priv = APPLET_GENERIC_APPLICATION_BUTTON(gobject)->priv;
    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_generic_application_button_class_init(AppletGenericApplicationButtonClass * klass)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);
    GParamSpec *pspec;
    gobject_class->set_property = applet_generic_application_button_set_property;
    gobject_class->get_property = applet_generic_application_button_get_property;

 //   g_type_class_add_private(klass, sizeof (AppletGenericApplicationButtonPrivate));
}

static void
applet_generic_application_button_init(AppletGenericApplicationButton * self)
{
   // AppletGenericApplicationButtonPrivate *priv;
  //  priv = self->priv = APPLET_GENERIC_APPLICATION_BUTTON_GET_PRIVATE(self);
}

AppletGenericApplicationButton *
applet_generic_application_button_new(void)
{
    AppletGenericApplicationButton *object = NULL;
    object = g_object_new(APPLET_TYPE_GENERIC_APPLICATION_BUTTON, NULL);
    return object;
}

void
applet_generic_application_button_constructor(AppletGenericApplicationButton *button, AppletMenu *applet_button, CdosApp *app, gboolean with_menu)
{
    PopupBaseMenuItemInit  params;
    AppletApplicationContextmenuItem *menu_item;
    CdosPopupMenu *menu;
    AppletMenu *applet;

    MonkeyPlugin *plugin = monkey_plugin_get();
    ClutterContainer *uigroup = monkey_plugin_get_ui_group(plugin);
    //CinnamonGenericContainer *actor;

    applet= applet_button;   //menu完成时再加入

    applet_button_set_applet_menu(button, applet_button);

//    button->app = app;
    applet_button_set_app(button, app);
    button->with_menu = with_menu;
 //   button->menu = NULL;

    cdos_popup_base_menu_item_get_init_params (&params);
    params.hover = FALSE;
    params.focusOnHover = FALSE;
    cdos_popup_base_menu_item_set_params (CDOS_POPUP_BASE_MENU_ITEM (button), &params);

    g_signal_connect(button, "activate", G_CALLBACK(applet_generic_application_button_activate), button);

    //调用applet-menu的函数部分未加
//    if(button->with_menu)
//    {
    	//actor = cdos_popup_base_menu_item_get_actor(button);
        menu = applet_contextmenu_new(button);
    	applet_button_set_popup_menu(button, menu);
        /*        st_widget_set_style_class_name(menu->actor, "menu-context-menu");
        menu_item = applet_application_contextmenu_item_new(button, "Add to panel", ADD_TO_PANEL);
        cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
        menu_item = applet_application_contextmenu_item_new(button, "Remove from panel", REMOVE_FROM_PANEL);
        cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
        menu_item = applet_application_contextmenu_item_new(button, "Add to desktop", ADD_TO_DESKTOP);
        cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
        menu_item = applet_application_contextmenu_item_new(button, "Remove from quick operation", REMOVE_FROM_FAVORITES);
        cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
        menu_item = applet_application_contextmenu_item_new(button, "Add to quick operation", ADD_TO_FAVORITES);
        cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
*/
        cdos_popup_menu_base_add_child_menu(applet->menu, menu);
        st_container_add_actor ((ClutterContainer *) uigroup, CLUTTER_ACTOR(menu->actor));

        st_widget_add_style_class_name(ST_WIDGET(menu->actor),"menu-context-menu");
 //   }
}

gboolean
applet_generic_application_button_set_active(AppletGenericApplicationButton *self)
{
	return TRUE;
}

void
applet_generic_application_button_activate(AppletGenericApplicationButton *self,  gpointer event, gboolean keep, gpointer data)
{
    g_return_if_fail (APPLET_IS_GENERIC_APPLICATION_BUTTON (self));

    CdosPopupMenu *menu;
    AppletMenu *applet_button;
    CdosApp *app;

    menu = applet_button_get_popup_menu(self);
    applet_button = applet_button_get_applet_menu(self);
    applet_menu_set_generic_application_button_popup_menu (applet_button, menu);   //zhangdj
    app = applet_button_get_app(self);

    guint event_type = clutter_event_get_button((ClutterEvent *)event);
    gfloat x, y;

    if(event_type == 1){
    	if(menu && CDOS_POPUP_MENU_BASE(menu)->is_open){
    		cdos_popup_menu_close(menu, TRUE);
    	}else{
			cdos_app_open_new_window (app, -1);
			cdos_popup_menu_close(applet_button->menu, TRUE);//.close没写
    	}
    }else if(event_type == 3){
        if(menu){ 
        	clutter_event_get_coords(event, &x, &y);
        	APPLET_CONTEXTMENU(menu)->x = x;
        	APPLET_CONTEXTMENU(menu)->y = y;
            applet_generic_application_button_toggle_menu(self);
            cdos_popup_menu_base_toggle(menu);
        }
    }
}

static gint 
index_of(const gchar **haystack, const gchar *needle)
{
        if (haystack == NULL || needle == NULL)
                return -1;

        int i = 0;    
        while(*haystack)
        {
            if (g_strcmp0(*haystack, needle) == 0) {
                return i;
            }
            haystack++;
            i++;
        }

        return -1;
}



void
applet_generic_application_button_toggle_menu(AppletGenericApplicationButton *button)
{
    CdosPopupMenu *menu;
    AppletMenu *applet_button;
    AppletApplicationContextmenuItem *menu_item;
    StBoxLayout *box;
    GSettings *settings;
    gchar **desktopFiles;
    CdosApp *app;
    gchar *id;
    CdosAppFavorites *app_fav;
    gchar *home_dir;
    gchar *path;
    GFile *dest_file;
    
	app_fav = cdos_app_favorites_get_default();   //zhangdj

    if (!button->with_menu)
        return;

    //home_dir = util_get_user_desktop_dir();    //zhangdj
    util_get_user_desktop_dir(&home_dir);    //zhangdj

    menu = applet_button_get_popup_menu(button);
    applet_button = applet_button_get_applet_menu(button);

    if (!CDOS_POPUP_MENU_BASE(menu)->is_open) {
        cdos_popup_menu_base_remove_all(menu);

        app = applet_button_get_app(button);
        id = cdos_app_get_id(app);
        settings = g_settings_new("org.cdos");
        desktopFiles = g_settings_get_strv(settings, "panel-launchers");

        if (index_of(desktopFiles, id) == -1) {

            menu_item = applet_application_contextmenu_item_new(button, _("Add to panel"), ADD_TO_PANEL);
            cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
        
        } else {

            menu_item = applet_application_contextmenu_item_new(button, _("Remove from panel"), REMOVE_FROM_PANEL);
            cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
        }


        if (home_dir) {
        	//zhangdj
        	path = g_strconcat(home_dir, "/", id, NULL);
        	dest_file = g_file_new_for_path(path);
        
            if (!g_file_query_exists (dest_file, NULL))
            {
            	menu_item = applet_application_contextmenu_item_new(button, _("Add to desktop"), ADD_TO_DESKTOP);
            	cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
            } else {
            	menu_item = applet_application_contextmenu_item_new(button, _("Remove from desktop"), REMOVE_FROM_DESKTOP);
            	cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
            }
        
        } 

        if (cdos_app_favorites_is_favorite(app_fav, id)) {
            menu_item = applet_application_contextmenu_item_new(button, _("Remove from quick operation"), REMOVE_FROM_FAVORITES);
            cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
        } else {
            menu_item = applet_application_contextmenu_item_new(button, _("Add to quick operation"), ADD_TO_FAVORITES);
            cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(menu), CDOS_POPUP_BASE_MENU_ITEM(menu_item), -1);
        }

    }
}

 
