#ifndef __APPLET_MENU_SWITCHS_H__
#define __APPLET_MENU_SWITCHS_H__

#include <glib.h>
#include <glib-object.h>
#include "cdos-popup-base-menu-item.h"
#include "applet-menu.h"
#include "st.h"
#include "config.h"

G_BEGIN_DECLS

#define APPLET_TYPE_MENU_SWITCHS                   (applet_menu_switchs_get_type ())
#define APPLET_MENU_SWITCHS(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_MENU_SWITCHS, AppletMenuSwitchs))
#define APPLET_IS_MENU_SWITCHS(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_MENU_SWITCHS))
#define APPLET_MENU_SWITCHS_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_MENU_SWITCHS, AppletMenuSwitchsClass))
#define APPLET_IS_MENU_SWITCHS_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_MENU_SWITCHS))
#define APPLET_MENU_SWITCHS_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_MENU_SWITCHS, AppletMenuSwitchsClass))

typedef struct _AppletMenuSwitchs AppletMenuSwitchs;
typedef struct _AppletMenuSwitchsPrivate AppletMenuSwitchsPrivate;
typedef struct _AppletMenuSwitchsClass AppletMenuSwitchsClass;

struct _AppletMenuSwitchs 
{
        CdosPopupBaseMenuItem     parent_instance;
        AppletMenuSwitchsPrivate  *priv;
};

struct _AppletMenuSwitchsClass 
{
    CdosPopupBaseMenuItemClass parent_class;
    void (*state_changed) (AppletMenuSwitchs *obj, guint status);   
};

GType
applet_menu_switchs_get_type(void) G_GNUC_CONST;

AppletMenuSwitchs *
applet_menu_switchs_new(void);

ClutterActor *
applet_menu_switchs_get_actor(AppletMenuSwitchs *switchs);


G_END_DECLS

#endif              /* __UI_BOX_POINTER_H__ */
