#ifndef __APPLET_RECENT_BUTTON_H__
#define __APPLET_RECENT_BUTTON_H__

#include <glib.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <gtk/gtk.h>
#include "cdos-popup-base-menu-item.h"
#include "applet-menu.h"
#include "cdos-doc-info.h"
#include "applet-generic-application-button.h"
#include "applet-application-contextmenu-item.h"
#include "applet-button.h"
#include "applet-contextmenu.h"



G_BEGIN_DECLS

#define APPLET_TYPE_RECENT_BUTTON                   (applet_recent_button_get_type ())
#define APPLET_RECENT_BUTTON(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_RECENT_BUTTON, AppletRecentButton))
#define APPLET_IS_RECENT_BUTTON(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_RECENT_BUTTON))
#define APPLET_RECENT_BUTTON_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_RECENT_BUTTON, AppletRecentButtonClass))
#define APPLET_IS_RECENT_BUTTON_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_RECENT_BUTTON))
#define APPLET_RECENT_BUTTON_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_RECENT_BUTTON, AppletRecentButtonClass))

typedef struct _AppletRecentButton AppletRecentButton;
typedef struct _AppletRecentButtonPrivate AppletRecentButtonPrivate;
typedef struct _AppletRecentButtonClass AppletRecentButtonClass;

struct _AppletRecentButton 
{
    AppletButton parent_instance;

    gchar *name;              
    AppletRecentButtonPrivate *priv;
};

struct _AppletRecentButtonClass 
{
    AppletButtonClass parent_class;
};

GType
applet_recent_button_get_type(void) G_GNUC_CONST;

AppletRecentButton *
applet_recent_button_new(AppletMenu *applet, CdosDocInfo *file);

gboolean
applet_recent_button_set_active(AppletRecentButton *self);

void 
applet_recent_button_activate(AppletRecentButton *self,  gpointer event, gboolean keep, gpointer data);

void 
applet_recent_button_toggle_menu(AppletRecentButton *self);

StLabel *
applet_recent_button_get_label(AppletRecentButton *self);



G_END_DECLS

#endif  /* __APPLET_RECENT_BUTTON_H__ */
