#include "applet-util.h"
#include <gio/gio.h>
#include <string.h>

gchar *
util_get_str(gchar *str, gchar first, gchar second)
{
    
        gint length = strlen(str);
        gchar *new_str = g_malloc(sizeof(gchar *)*length);
        gchar *strstr=new_str;
        gboolean flag = FALSE;

        while(*str)
        {
                if (*str == first)
                {
                        flag = TRUE;
                }

                if (*str == second)
                {
                        if (flag)
                        {
                                *new_str = '\0';
                                break;
                        }
                }

                if (flag) 
                {
                        *new_str++ = *str;
                }

                str++;
        }

        return strstr;
}

void
util_get_user_desktop_dir(gchar **home_dir)
{
        const gchar *home_path = g_get_home_dir();
        gchar *path = g_strconcat(home_path, "/.config/user-dirs.dirs", NULL);
        GFile *file = g_file_new_for_path(path);

//        gchar *result = NULL;
//	gchar *result2 = NULL;


        if (g_file_query_exists(file, NULL)) {
		// If in user-dirs
                gchar **content = g_malloc(sizeof(gchar *)*1);
                gsize length;
                gboolean flag = g_file_load_contents(file, NULL, content, &length, NULL, NULL);
                gchar **lines = g_strsplit(*content, "\n", -1);
                while(*lines) 
                {
                        if (*lines[0]=='#') {
                                lines++;
                                continue;
                        } 

                        gchar *sta = strstr(*lines, "XDG_DESKTOP_DIR");

                        if (sta) {

                                gchar **m = g_strsplit(*lines, "=",2);
                                guint length = strlen(*(m+1));
                                 
                                gchar *tmp = util_get_str(*(m+1), '/', '\"');
                               
                                *home_dir = g_strconcat(home_path, tmp, NULL);
                        }

                       lines++;         
                }
        }

	g_print ("%s %d, %s\n", __func__, __LINE__, *home_dir);
//        GFile *test = g_file_new_for_path(result2);

	if (*home_dir == NULL)
        	*home_dir = g_strconcat(home_path, "/Desktop", NULL);
/*        if (g_file_query_exists(test, NULL)){
            return g_strdup(result2);
	}else {
        	return g_strdup(result);
	}*/
}





