#ifndef  __CDOS_SCALE_H__
#define  __CDOS_SCALE_H__

#include <clutter/clutter.h>
//#include "cdos-overview.h"
#include "cdos.h"
#include "st.h"

#define CDOS_TYPE_SCALE                	              (cdos_scale_get_type())
#define CDOS_SCALE(obj)                     	      (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_SCALE, CdosScale))
#define CDOS_IS_SCALE(obj)               	      (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_SCALE))
#define CDOS_SCALE_CLASS(kclass)               	      (G_TYPE_CHECK_CLASS_CAST((kclass), CDOS_TYPE_SCALE, CdosScaleClass))
#define CDOS_IS_SCALE_CLASS(kclass)    	     	      (G_TYPE_CHECK_CLASS_TYPE((kclass), CDOS_TYPE_SCALE))
#define CDOS_SCALE_GET_CLASS(obj)             	      (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_SCALE, CdosScaleClass))

typedef struct _CdosScale                           CdosScale;
typedef struct _CdosScalePrivate                    CdosScalePrivate;
typedef struct _CdosScaleClass                 CdosScaleClass;


struct _CdosScale
{
   CdosIconApplet  parent_instance;

   CdosScalePrivate *priv;
};

struct _CdosScaleClass
{
    CdosIconAppletClass parent_class;

};

void on_entered(CdosScale *self,ClutterEvent *event);

//void on_entered(CdosScale *self,ClutterEvent *event)
//CdosScale * cdos_scale_main(MetaData *meta,guint orientation, gfloat panel_height, gchar *instance_id);

CdosScale * cdos_scale_new(MetaData *metadata,guint orientation, gfloat panel_height, gchar *instance_id);


#endif

