//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialMenus.js

#ifndef __APPLET_APP_SWITCHER_ITEM_H__
#define __APPLET_APP_SWITCHER_ITEM_H__
#include <glib-object.h>
#include <meta/window.h>
#include "applet-window-list-private.h"
#include "cdos-popup-base-menu-item.h"
#include "cdos-app.h"
#include "st.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_APP_SWITCHER_ITEM (applet_app_switcher_item_get_type())
//强制类型转换;
#define APPLET_APP_SWITCHER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APP_SWITCHER_ITEM,AppletAppSwitcherItem))
//检测类型实例
#define APPLET_IS_APP_SWITCHER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APP_SWITCHER_ITEM))
//类型转换(可选)
#define APPLET_APP_SWITCHER_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APP_SWITCHER_ITEM,AppletAppSwitcherItemClass))
//检测是否是类的成员(可选)
#define APPLET_IS_APP_SWITCHER_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APP_SWITCHER_ITEM))
//获取实例对象的类结构(可选)
#define APPLET_APP_SWITCHER_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_APP_SWITCHER_ITEM,AppletAppSwitcherItemClass))

//定义对象实例
//typedef struct _AppletAppSwitcherItem AppletAppSwitcherItem;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletAppSwitcherItemClass AppletAppSwitcherItemClass;

typedef struct _AppletAppSwitcherItemPrivate AppletAppSwitcherItemPrivate;
typedef struct _AppletAppSwitcherItemParams AppletAppSwitcherItemParams;

struct _AppletAppSwitcherItem {
    CdosPopupBaseMenuItem parent;

    /*private*/
    AppletAppSwitcherItemPrivate *priv;
};
struct _AppletAppSwitcherItemClass {
    CdosPopupBaseMenuItemClass parent_class;
};

struct _AppletAppSwitcherItemParams{
    gboolean hover;
    gboolean is_favorite_app;
    AppletWindowList *applet;
    MetaWindow *meta_window;
    CdosApp *app;
};

//取得对象类型ID;
GType	applet_app_switcher_item_get_type(void);
//创建对象实例;
AppletAppSwitcherItem*  applet_app_switcher_item_new(AppletAppSwitcherItemParams *params);

//对象的属性成员方法列表;
void  applet_app_switcher_item_set_meta_window(AppletAppSwitcherItem *self,MetaWindow *meta_window);

void  applet_app_switcher_item_add_new_windows(AppletAppSwitcherItem *self,GSList *windows);

void  applet_app_switcher_item_add_windows_loop(
        AppletAppSwitcherItem *self,
        gint i,gint win_length,StWidget *actor,GSList *windows,gint container_num
);

void  applet_app_switcher_item_remove_old_windows(AppletAppSwitcherItem *self,GSList *windows);

void applet_app_switcher_item_is_favorite(AppletAppSwitcherItem *self,gboolean is_added);

void applet_app_switcher_item_refresh(AppletAppSwitcherItem *self);

//getter and setter functions;
MetaWindow* applet_app_switcher_item_get_meta_window(AppletAppSwitcherItem *self);

CdosApp* applet_app_switcher_item_get_app(AppletAppSwitcherItem *self);

gboolean applet_app_switcher_item_get_is_favorite_app(AppletAppSwitcherItem *self);

void applet_app_switcher_item_set_is_favorite_app(AppletAppSwitcherItem *self,gboolean is_favorite_app);

StWidget* applet_app_switcher_item_get_box(AppletAppSwitcherItem *self);

AppletWindowThumbnail* applet_app_switcher_item_get_meta_window_thumbnail(AppletAppSwitcherItem *self);




#endif //__APPLET_APP_SWITCHER_ITEM_H__
