//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialMenus.js

#ifndef __APPLET_APP_THUMBNAIL_HOVER_MENU_H__
#define __APPLET_APP_THUMBNAIL_HOVER_MENU_H__
#include <glib-object.h>
#include <meta/window.h>

#include "applet-window-list-private.h"
#include "cdos-popup-menu.h"
#include "cdos-app.h"
#include "applet-app-switcher-item.h"
#include "st.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_APP_THUMBNAIL_HOVER_MENU (applet_app_thumbnail_hover_menu_get_type())
//强制类型转换;
#define APPLET_APP_THUMBNAIL_HOVER_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APP_THUMBNAIL_HOVER_MENU,AppletAppThumbnailHoverMenu))
//检测类型实例
#define APPLET_IS_APP_THUMBNAIL_HOVER_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APP_THUMBNAIL_HOVER_MENU))
//类型转换(可选)
#define APPLET_APP_THUMBNAIL_HOVER_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APP_THUMBNAIL_HOVER_MENU,AppletAppThumbnailHoverMenuClass))
//检测是否是类的成员(可选)
#define APPLET_IS_APP_THUMBNAIL_HOVER_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APP_THUMBNAIL_HOVER_MENU))
//获取实例对象的类结构(可选)
#define APPLET_APP_THUMBNAIL_HOVER_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_APP_THUMBNAIL_HOVER_MENU,AppletAppThumbnailHoverMenuClass))

//定义对象实例
typedef struct _AppletAppThumbnailHoverMenu AppletAppThumbnailHoverMenu;
typedef struct _AppletAppThumbnailHoverMenuPrivate AppletAppThumbnailHoverMenuPrivate;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletAppThumbnailHoverMenuClass AppletAppThumbnailHoverMenuClass;

typedef struct _AppletAppThumbnailHoverMenuParams AppletAppThumbnailHoverMenuParams;

struct _AppletAppThumbnailHoverMenu {
    CdosPopupMenu parent;
    /*private*/
    AppletAppThumbnailHoverMenuPrivate *priv;
};
struct _AppletAppThumbnailHoverMenuClass {
    CdosPopupMenuClass parent_class;
};
struct _AppletAppThumbnailHoverMenuParams{
    StWidget *actor;
    StSide orientation;
    MetaWindow *meta_window;
    CdosApp *app;
    gboolean is_favorite_app;
    AppletWindowList *applet;
};

//取得对象类型ID;
GType	applet_app_thumbnail_hover_menu_get_type(void);
//创建对象实例;
AppletAppThumbnailHoverMenu*  applet_app_thumbnail_hover_menu_new(AppletAppThumbnailHoverMenuParams *params);

//对象的属性成员方法列表;

void applet_app_thumbnail_hover_menu_open(AppletAppThumbnailHoverMenu *self,gboolean animate);

void applet_app_thumbnail_hover_menu_close(AppletAppThumbnailHoverMenu *self,gboolean animate);

void applet_app_thumbnail_hover_menu_destroy(AppletAppThumbnailHoverMenu *self);

void applet_app_thumbnail_hover_menu_set_meta_window(AppletAppThumbnailHoverMenu *self,MetaWindow *meta_window);

void applet_app_thumbnail_hover_menu_hover_close(AppletAppThumbnailHoverMenu *self);

void applet_app_thumbnail_hover_menu_hover_open(AppletAppThumbnailHoverMenu *self);

void applet_app_thumbnail_hover_menu_refresh(AppletAppThumbnailHoverMenu *self);

//getter and setter functions;
MetaWindow* applet_app_thumbnail_hover_menu_get_meta_window(AppletAppThumbnailHoverMenu *self);

CdosApp* applet_app_thumbnail_hover_menu_get_app(AppletAppThumbnailHoverMenu *self);

gboolean applet_app_thumbnail_hover_menu_get_is_favorite_app(AppletAppThumbnailHoverMenu *self);

StWidget* applet_app_thumbnail_hover_menu_get_parent_actor(AppletAppThumbnailHoverMenu *self);

StWidget* applet_app_thumbnail_hover_menu_get_actor(AppletAppThumbnailHoverMenu *self);

AppletAppSwitcherItem* applet_app_thumbnail_hover_menu_get_app_switcher_item(AppletAppThumbnailHoverMenu *self);

gboolean applet_app_thumbnail_hover_menu_get_should_open(AppletAppThumbnailHoverMenu *self);

void applet_app_thumbnail_hover_menu_set_should_open(AppletAppThumbnailHoverMenu *self,gboolean should_open);

gboolean applet_app_thumbnail_hover_menu_get_should_close(AppletAppThumbnailHoverMenu *self);

void applet_app_thumbnail_hover_menu_set_should_close(AppletAppThumbnailHoverMenu *self,gboolean should_close);

void applet_app_thumbnail_hover_menu_set_context_menu(AppletAppThumbnailHoverMenu *self,AppletAppContextMenu *context_menu);

void applet_app_thumbnail_hover_menu_set_is_keep_menu(AppletAppThumbnailHoverMenu *self,gboolean is_keep_menu);

#endif //__APPLET_APP_THUMBNAIL_HOVER_MENU_H__
