//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#ifndef __APPLET_APP_TRACKER_H__
#define __APPLET_APP_TRACKER_H__
#include <glib-object.h>
#include <meta/window.h>

#include "applet-window-list-private.h"
#include "cdos-window-tracker.h"
#include "applet-ordered-hash.h"
#include "cdos-app.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_APP_TRACKER (applet_app_tracker_get_type())
//强制类型转换;
#define APPLET_APP_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APP_TRACKER,AppletAppTracker))
//检测类型实例
#define APPLET_IS_APP_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APP_TRACKER))
//类型转换(可选)
#define APPLET_APP_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APP_TRACKER,AppletAppTrackerClass))
//检测是否是类的成员(可选)
#define APPLET_IS_APP_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APP_TRACKER))
//获取实例对象的类结构(可选)
#define APPLET_APP_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_APP_TRACKER,AppletAppTrackerClass))

//定义对象实例
//typedef struct _AppletAppTracker AppletAppTracker;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletAppTrackerClass AppletAppTrackerClass;

typedef struct _AppletAppTrackerPrivate AppletAppTrackerPrivate;

struct _AppletAppTracker {
    GObject parent;
    /*private*/
    AppletAppTrackerPrivate *priv;
};
struct _AppletAppTrackerClass {
    GObjectClass parent_class;
};
//取得对象类型ID;
GType	applet_app_tracker_get_type(void);
//创建对象实例;
AppletAppTracker*  applet_app_tracker_new(CdosWindowTracker *tracker);

//对象的属性成员方法列表;
CdosApp* applet_app_tracker_get_window_app(AppletAppTracker *self,MetaWindow *meta_window);

//getter and setter functions;
CdosWindowTracker* applet_app_tracker_get_cdos_window_tracker(AppletAppTracker *self);

void applet_app_tracker_set_cdos_window_tracker(AppletAppTracker *self,CdosWindowTracker *tracker);

void applet_app_tracker_remove_window(AppletAppTracker *self,MetaWindow *meta_window);



#endif //__APPLET_APP_TRACKER_H__
