//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialButtons.js

#ifndef __APPLET_BUTTON_BOX_H__
#define __APPLET_BUTTON_BOX_H__

#include <clutter/clutter.h>
#include <glib-object.h>
#include "applet-window-list-private.h"
#include "st.h"


//直接取得并替代对象ID标示符;
#define APPLET_TYPE_BUTTON_BOX (applet_button_box_get_type())
//强制类型转换;
#define APPLET_BUTTON_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_BUTTON_BOX,AppletButtonBox))
//检测类型实例
#define APPLET_IS_BUTTON_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_BUTTON_BOX))
//类型转换(可选)
#define APPLET_BUTTON_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_BUTTON_BOX,AppletButtonBoxClass))
//检测是否是类的成员(可选)
#define APPLET_IS_BUTTON_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_BUTTON_BOX))
//获取实例对象的类结构(可选)
#define APPLET_BUTTON_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_BUTTON_BOX,AppletButtonBoxClass))

//定义对象实例
//typedef struct _AppletButtonBox AppletButtonBox;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletButtonBoxClass AppletButtonBoxClass;

typedef struct _AppletButtonBoxPrivate AppletButtonBoxPrivate;

struct _AppletButtonBox {
    GObject parent;
    /*private*/
    AppletButtonBoxPrivate *priv;
};
struct _AppletButtonBoxClass {
    GObjectClass parent_class;
};
//取得对象类型ID;
GType	applet_button_box_get_type(void);
//创建对象实例;
AppletButtonBox*  applet_button_box_new(void);

//对象的属性成员方法列表;
void applet_button_box_show(AppletButtonBox *self,gboolean animate,gfloat target_width);

void applet_button_box_hide(AppletButtonBox *self,gboolean animate);

void applet_button_box_add(AppletButtonBox *self,ClutterActor *actor);

void applet_button_box_remove(AppletButtonBox *self,ClutterActor *actor);

void applet_button_box_clear(AppletButtonBox *self);

void applet_button_box_hide_fav(AppletButtonBox *self);

void applet_button_box_destroy(AppletButtonBox *self);

//getter and setter functions;
StWidget* applet_button_box_get_actor(AppletButtonBox *self);


#endif //__APPLET_BUTTON_BOX_H__
