/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_SLICER_H__
#define __CDOS_SLICER_H__

#include "st.h"

#define CDOS_TYPE_SLICER                 (cdos_slicer_get_type ())
#define CDOS_SLICER(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_SLICER, CdosSlicer))
#define CDOS_SLICER_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_SLICER, CdosSlicerClass))
#define CDOS_IS_SLICER(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_SLICER))
#define CDOS_IS_SLICER_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_SLICER))
#define CDOS_SLICER_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SLICER, CdosSlicerClass))

typedef struct _CdosSlicer        CdosSlicer;
typedef struct _CdosSlicerClass   CdosSlicerClass;

typedef struct _CdosSlicerPrivate CdosSlicerPrivate;

struct _CdosSlicer
{
    StBin parent;

    CdosSlicerPrivate *priv;
};

struct _CdosSlicerClass
{
    StBinClass parent_class;
};

GType cdos_slicer_get_type (void) G_GNUC_CONST;

#endif /* __CDOS_SLICER_H__ */
