/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_STACK_H__
#define __CDOS_STACK_H__

#include "st.h"
#include <gtk/gtk.h>

#define CDOS_TYPE_STACK                 (cdos_stack_get_type ())
#define CDOS_STACK(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_STACK, CdosStack))
#define CDOS_STACK_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_STACK, CdosStackClass))
#define CDOS_IS_STACK(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_STACK))
#define CDOS_IS_STACK_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_STACK))
#define CDOS_STACK_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_STACK, CdosStackClass))

typedef struct _CdosStack        CdosStack;
typedef struct _CdosStackClass   CdosStackClass;

typedef struct _CdosStackPrivate CdosStackPrivate;

struct _CdosStack
{
    StContainer parent;

    CdosStackPrivate *priv;
};

struct _CdosStackClass
{
    StContainerClass parent_class;
};

GType cdos_stack_get_type (void) G_GNUC_CONST;

#endif /* __CDOS_STACK_H__ */
