#ifndef __CDOS_APPLET_SETTINGS_H__
#define __CDOS_APPLET_SETTINGS_H__

#include "st.h"
#include "cdos-provider.h"

G_BEGIN_DECLS

#define CDOS_TYPE_APPLET_SETTINGS  (cdos_applet_settings_get_type())

#define CDOS_APPLET_SETTINGS(obj)  \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_APPLET_SETTINGS, CdosAppletSettings))

#define CDOS_IS_APPLET_SETTINGS(obj) \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_APPLET_SETTINGS))

#define CDOS_APPLET_SETTINGS_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_APPLET_SETTINGS, CdosAppletSettingsClass))

#define CDOS_IS_APPLET_SETTINGS_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_APPLET_SETTINGS ))

#define CDOS_APPLET_SETTINGS_GET_CLASS(obj) \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_APPLET_SETTINGS, CdosAppletSettingsClass ))

typedef struct _CdosAppletSettings CdosAppletSettings;
typedef struct _CdosAppletSettingsPrivate CdosAppletSettingsPrivate;
typedef struct _CdosAppletSettingsClass CdosAppletSettingsClass;


struct _CdosAppletSettings
{
    CdosProvider parent_instance;
};

struct _CdosAppletSettingsClass
{
    CdosProviderClass parent_class;
};

GType cdos_applet_settings_get_type(void) G_GNUC_CONST;

CdosAppletSettings *
cdos_applet_settings_new(GObject *xlet, const gchar *uuid, const gchar *instanceId);

gboolean 
cdos_applet_settings_get_is_multi_instance_xlet(CdosAppletSettings *settings,
                                                                                const gchar *uuid);

G_END_DECLS

#endif /*__CDOS_APPLET_SETTINGS_H__*/
