#include "cdos-desklet-settings.h"
#include "cdos-extension.h"
#include "cdos-extension-type.h"


#define CDOS_DESKLRY_SETTINGS_GET_PRIVATE(obj)    \
        (G_TYPE_INSTANCE_GET_PRIVATE((obj), CDOS_TYPE_DESKLET_SETTINGS, CdosDeskletSettingsPrivate))

G_DEFINE_TYPE(CdosDeskletSettings, cdos_desklet_settings, CDOS_TYPE_PROVIDER);

static void
cdos_desklet_settings_class_init(CdosDeskletSettingsClass *klass)
{
        /*nothing*/
}

static void
cdos_desklet_settings_init(CdosDeskletSettings *settings)
{
        /*nothing*/
}

CdosDeskletSettings *
cdos_desklet_settings_new(GObject *xlet, const gchar *uuid, gchar *instanceId)
{
        GObject *obj;       
        obj = g_object_new(CDOS_TYPE_DESKLET_SETTINGS, NULL);
        CdosExtensionType *type = cdos_extension_get_extension_type(TYPE_DESKLET);
        cdos_provider_set_params(obj, xlet, uuid, instanceId,  type, "Desklet");
        return CDOS_DESKLET_SETTINGS(obj);
}

gboolean 
cdos_desklet_settings_get_is_multi_instance_xlet(CdosDeskletSettings *settings,
                                                                                const gchar *uuid)
{
        return cdos_extension_get_max_instances(uuid) > 1;
}


