//
// Created by zhangtao on 16-3-15.
// source:edgeFlip.js

#ifndef __CDOS_EDGE_FLIPPER_H__
#define __CDOS_EDGE_FLIPPER_H__


#include <glib-object.h>
//直接取得并替代对象ID标示符;
#define CDOS_TYPE_EDGE_FLIPPER (cdos_edge_flipper_get_type())
//强制类型转换;
#define CDOS_EDIG_FLIPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_EDGE_FLIPPER,CdosEdgeFlipper))
//检测类型实例
#define CDOS_IS_EDIG_FLIPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_EDGE_FLIPPER))
//类型转换(可选)
#define CDOS_EDIG_FLIPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_EDGE_FLIPPER,CdosEdgeFlipperClass))
//检测是否是类的成员(可选)
#define CDOS_IS_EDIG_FLIPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_EDGE_FLIPPER))
//获取实例对象的类结构(可选)
#define CDOS_EDIG_FLIPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_EDGE_FLIPPER,CdosEdgeFlipperClass))
//定义对象实例
typedef struct _CdosEdgeFlipper CdosEdgeFlipper;
//定义对象的类结构，全部对象实例所共有,（通常处理信号和事件）；
typedef struct _CdosEdgeFlipperClass CdosEdgeFlipperClass;

typedef struct _CdosEdgeFlipperPrivate CdosEdgeFlipperPrivate;


struct _CdosEdgeFlipper {
    GObject parent;
    /*private*/
    CdosEdgeFlipperPrivate *priv;
};
struct _CdosEdgeFlipperClass {
    GObjectClass parent_class;
    /*public*/
};

//取得对象类型ID;
GType	cdos_edge_flipper_get_type(void);

//创建对象实例;
CdosEdgeFlipper*  cdos_edge_flipper_new(StSide side);

//对象的属性成员方法列表;


//getter and setter list;
StSide cdos_edge_flipper_get_side(CdosEdgeFlipper *self);

void cdos_edge_flipper_set_side(CdosEdgeFlipper *self,StSide side);

gboolean cdos_edge_flipper_get_enabled(CdosEdgeFlipper *self);

void cdos_edge_flipper_set_enabled(CdosEdgeFlipper *self,gboolean enabled);

guint cdos_edge_flipper_get_delay(CdosEdgeFlipper *self);

void cdos_edge_flipper_set_delay(CdosEdgeFlipper *self,guint delay);

gboolean cdos_edge_flipper_get_entered(CdosEdgeFlipper *self);

void cdos_edge_flipper_set_entered(CdosEdgeFlipper *self,gboolean entered);

gboolean cdos_edge_flipper_get_activated(CdosEdgeFlipper *self);

void cdos_edge_flipper_set_activated(CdosEdgeFlipper *self,gboolean activated);

gint cdos_edge_flipper_get_x_mouse(CdosEdgeFlipper *self);

gint cdos_edge_flipper_get_y_mouse(CdosEdgeFlipper *self);


#endif //__DEV_CDOS_EDGE_FLIPPER_H__
