#include "cdos-extension-settings.h"
#include "cdos-extension.h"
#include "cdos-extension-type.h"

#define CDOS_APPLET_SETTINGS_GET_PRIVATE(obj)    \
        (G_TYPE_INSTANCE_GET_PRIVATE((obj), CDOS_TYPE_EXTENSION_SETTINGS, CdosExtensionSettingsPrivate))

G_DEFINE_TYPE(CdosExtensionSettings, cdos_extension_settings, CDOS_TYPE_PROVIDER);

static void
cdos_extension_settings_class_init(CdosExtensionSettingsClass *klass)
{
        /*do nothing*/
}

static void
cdos_extension_settings_init(CdosExtensionSettings *settings)
{
        /*do nothing*/
}

/**
 * func_name:
 * @xlet: GObject * xlet
 * @uuid: uuid
 *
 * 新建一个 #CdosExtensionSettings 类的实例。
 *
 * Returns: 返回一个 #CdosExtensionSettings 的实例。
 */
CdosExtensionSettings *
cdos_extension_settings_new(GObject *xlet, const gchar *uuid)
{
        GObject *obj;       
        obj = g_object_new(CDOS_TYPE_EXTENSION_SETTINGS, NULL);
        CdosExtensionType *type = cdos_extension_get_extension_type(TYPE_EXTENSION);
        cdos_provider_set_params(obj, xlet, uuid, NULL, type, "Extension");
        return obj;
}

/**
 * cdos_extension_settings_new:
 * @xlet: GObject * xlet
 * @uuid: uuid
 *
 * get is multi instance xlet
 *
 * Returns: FALSE;
 */
gboolean 
cdos_extension_settings_get_is_multi_instance_xlet(CdosExtensionSettings *settings, const gchar *uuid)
{
        return FALSE;
}


