#ifndef __CDOS_EXTENSION_SETTINGS_H__
#define __CDOS_EXTENSION_SETTINGS_H__

#include "st.h"
#include "cdos-provider.h"

G_BEGIN_DECLS

#define CDOS_TYPE_EXTENSION_SETTINGS  (cdos_extension_settings_get_type())

#define CDOS_EXTENSION_SETTINGS(obj)  \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_EXTENSION_SETTINGS, CdosExtensionSettings))

#define CDOS_IS_EXTENSION_SETTINGS(obj) \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_EXTENSION_SETTINGS))

#define CDOS_EXTENSION_SETTINGS_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_EXTENSION_SETTINGS, CdosExtensionSettingsClass))

#define CDOS_IS_EXTENSION_SETTINGS_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_EXTENSION_SETTINGS ))

#define CDOS_EXTENSION_SETTINGS_GET_CLASS(obj) \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_EXTENSION_SETTINGS, CdosExtensionSettingsClass ))

typedef struct _CdosExtensionSettings CdosExtensionSettings;
typedef struct _CdosExtensionSettingsPrivate CdosExtensionSettingsPrivate;
typedef struct _CdosExtensionSettingsClass CdosExtensionSettingsClass;


struct _CdosExtensionSettings
{
    CdosProvider parent_instance;
};

struct _CdosExtensionSettingsClass
{
    GObjectClass parent_class;
};

GType cdos_extension_settings_get_type(void) G_GNUC_CONST;

CdosExtensionSettings *cdos_extension_setting_new(GObject *xlet, const gchar *uuid);

gboolean 
cdos_extension_settings_get_is_multi_instance_xlet(CdosExtensionSettings *settings, const gchar *uuid);

G_END_DECLS

#endif /*__CDOS_EXTENSION_SETTINGS_H__*/
