//
// Created by zhangtao on 16-3-15.
// source:overview.js

#ifndef __CDOS_OVERVIEW_H__
#define __CDOS_OVERVIEW_H__

#include <glib-object.h>
#include "st.h"

#define CDOS_TYPE_OVERVIEW (cdos_overview_get_type())
#define CDOS_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_OVERVIEW,CdosOverview))
#define CDOS_IS_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_OVERVIEW))
#define CDOS_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_OVERVIEW,CdosOverviewClass))
#define CDOS_IS_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_OVERVIEW))
#define CDOS_OVERVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_OVERVIEW,CdosOverviewClass))

typedef struct _CdosOverview CdosOverview;
typedef struct _CdosOverviewClass CdosOverviewClass;

typedef struct _CdosOverviewPrivate CdosOverviewPrivate;

struct _CdosOverview {
    //StGroup parent_instance;
    StWidget parent;
    gboolean animation_in_progress;
    CdosOverviewPrivate *priv;
};

struct _CdosOverviewClass {
    //StGroupClass parent_class;
    StWidgetClass parent_class;

    // signals
    void (*overview_background_button_press) (CdosOverview *instance);
    void (*overview_background_button_release)(CdosOverview *instance);
};

GType	cdos_overview_get_type(void);

CdosOverview*  cdos_overview_new(void);

void  cdos_overview_toggle(CdosOverview *self);

void  cdos_overview_set_scroll_adjustment(CdosOverview *self,StAdjustment *adjustment,gint direction);

void  cdos_overview_start(CdosOverview *self);

gboolean cdos_overview_get_hidding (CdosOverview *overview);

CdosOverview *cdos_overview_get ();

#endif //__CDOS_OVERVIEW_H__
