#ifndef __CDOS_POPUP_SEPARATOR_MENU_ITEM_H__
#define __CDOS_POPUP_SEPARATOR_MENU_ITEM_H__

#include "cdos-popup-base-menu-item.h"

#define CDOS_TYPE_POPUP_SEPARATOR_MENU_ITEM    \
        (cdos_popup_separator_menu_item_get_type())
#define CDOS_POPUP_SEPARATOR_MENU_ITEM(obj)    \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_POPUP_SEPARATOR_MENU_ITEM, CdosPopupSeparatorMenuItem))
#define CDOS_IS_POPUP_SEPARATOR_MENU_ITEM(obj)    \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_POPUP_SEPARATOR_MENU_ITEM))
#define CDOS_POPUP_SEPARATOR_MENU_ITEM_CLASS(klass)    \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_POPUP_SEPARATOR_MENU_ITEM, CdosPopupSeparatorMenuItemClass))
#define CDOS_IS_POPUP_SEPARATOR_MENU_ITEM_CLASS(klass)    \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_POPUP_SEPARATOR_MENU_ITEM ))
#define CDOS_POPUP_SEPARATOR_MENU_ITEM_GET_CLASS(obj)    \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_POPUP_SEPARATOR_MENU_ITEM, CdosPopupSeparatorMenuItemClass))

typedef struct _CdosPopupSeparatorMenuItem CdosPopupSeparatorMenuItem;
typedef struct _CdosPopupSeparatorMenuItemPrivate CdosPopupSeparatorMenuItemPrivate;
typedef struct  _CdosPopupSeparatorMenuItemClass CdosPopupSeparatorMenuItemClass;

struct _CdosPopupSeparatorMenuItem
{
	CdosPopupBaseMenuItem              parent_instance;
	CdosPopupSeparatorMenuItemPrivate  *priv;

};

struct  _CdosPopupSeparatorMenuItemClass
{
	CdosPopupBaseMenuItemClass 	parent_class;
};

GType  cdos_popup_separator_menu_item_get_type(void) G_GNUC_CONST;

CdosPopupSeparatorMenuItem  *cdos_popup_separator_menu_item_new(void);

void cdos_popup_separator_menu_item_hide(CdosPopupSeparatorMenuItem *item);

void cdos_popup_separator_menu_item_show(CdosPopupSeparatorMenuItem *item);

StDrawingArea *cdos_popup_separator_menu_item_get_drawing_area (CdosPopupSeparatorMenuItem *item);

#endif /*__CDOS_POPUP_SEPARATOR_MENU_ITEM_H__*/
