#ifndef __CDOS_SCREEN_SAVER_H__
#define __CDOS_SCREEN_SAVER_H__

#include <glib-object.h>
#include <gio/gio.h>

GType cdos_screen_saver_get_type (void);

#define CDOS_TYPE_SCREEN_SAVER		(cdos_screen_saver_get_type ())
#define CDOS_SCREEN_SAVER(obj)              (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_SCREEN_SAVER, CdosScreenSaver))
#define CDOS_IS_SCREEN_SAVER(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_SCREEN_SAVER))
#define CDOS_SCREEN_SAVER_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_SCREEN_SAVER, CdosScreenSaverClass))
#define CDOS_IS_SCREEN_SAVER_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_SCREEN_SAVER))
#define CDOS_SCREEN_SAVER_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SCREEN_SAVER, CdosScreenSaverClass))

typedef struct _CdosScreenSaver		CdosScreenSaver;
typedef struct _CdosScreenSaverClass      	CdosScreenSaverClass;

struct _CdosScreenSaverClass
{
	GObjectClass parent_class;

	
};

struct _CdosScreenSaver
{
        GObject parent_instance;
	
	gboolean screenSaverActive;
        GDBusProxy *proxy;
	guint watchID;

};

CdosScreenSaver *cdos_screen_saver_proxy_new (void);

#endif
