#ifndef __CDOS_H__
#define __CDOS_H__

#include "config.h"

#include "cdos-types.h"
#include "cdos-confirm-dialog.h"
#include "cdos-dnd.h"
#include "cdos-lightbox.h"
#include "cdos-modal-dialog.h"
#include "cdos-layout-manager.h"
#include "cdos-window-manager.h"
#include "cdos-applet-settings.h"
#include "cdos-panel.h"
#include "cdos-applet.h"
#include "cdos-theme-manager.h"
#include "cdos-extension.h"
#include "cdos-popup.h"
#include "cdos-utils-private.h"
#include "cdos-showdesktop.h"
#include "cdos-systray.h"
#include "cdos-monkey-plugin.h"
#include "cdos-overview.h"

#ifndef GLOBAL
#define GLOBAL cdos_global_get()
#define CDOS_WM cdos_global_get_window_manager(GLOBAL)
#endif

#define PLUGIN_PANEL cdos_panel

// tmp
#include "cdos-debug.h"

#if !defined(true)
#define true 1
#endif
#if !defined(false)
#define false 0
#endif

#undef max
#undef MAX
#if defined __USE_GNU && __GNUC__ >= 5
#define max(a,b) ({__auto_type _a=(a);\
                   __auto_type _b=(b);\
                   _a > _b ? _a : _b;\
                  })
#else
#define max(a,b) (a)>(b)?(a):(b)
#endif
#define MAX(a,b) max(a, b)

#undef min
#undef MIN
#if defined __USE_GNU && __GNUC__ >= 5
#define min(a,b) ({__auto_type _a=(a);\
                   __auto_type _b=(b);\
                   _a > _b ? _b : _a;\
                 })
#else
#define min(a,b) (a)>(b)?(b):(a)
#endif
#define MIN(a,b) min(a,b)

#if defined __USE_GNU && __GNUC__ >= 5
#define mod(a,b) ({__auto_type _a=(a);\
                   __auto_type _b=(b);\
                   (_a+_b)%_b;\
                  })
#else
#define mod(a,b) ((a)+(b))%(b)
#endif

#endif // __CDOS_H__
