#ifndef __APPLET_APPLICATION_MENU_H__
#define __APPLET_APPLICATION_MENU_H__

#include <glib.h>
#include <glib-object.h>
#include "st.h"
#include "cdos-popup-menu.h"
#include "cdos-popup-base-menu-item.h"
#include "cdos-util.h"
#include "applet-menu.h"

G_BEGIN_DECLS

#define APPLET_TYPE_APPLICATION_MENU                   (applet_application_menu_get_type ())
#define APPLET_APPLICATION_MENU(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_APPLICATION_MENU, AppletApplicationMenu))
#define APPLET_IS_APPLICATION_MENU(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_APPLICATION_MENU))
#define APPLET_APPLICATION_MENU_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_APPLICATION_MENU, AppletApplicationMenuClass))
#define APPLET_IS_APPLICATION_MENU_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_APPLICATION_MENU))
#define APPLET_APPLICATION_MENU_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_APPLICATION_MENU, AppletApplicationMenuClass))

typedef struct _AppletApplicationMenu AppletApplicationMenu;
typedef struct _AppletApplicationMenuClass AppletApplicationMenuClass;

struct _AppletApplicationMenu {
    CdosPopupMenuBase parent_instance;
    /*< private > */
    StBoxLayout *actor;
};

struct _AppletApplicationMenuClass {
	CdosPopupMenuBaseClass parent_class;
};

GType
applet_application_menu_get_type(void) G_GNUC_CONST;

CdosPopupMenu *
applet_application_menu_new(StWidget *stource_actor);

void applet_application_menu_togglex(AppletApplicationMenu * self);

void
applet_application_menu_openx(AppletApplicationMenu * self);

void
applet_application_menu_closex(AppletApplicationMenu * self);

G_END_DECLS

#endif              /* __UI_BOX_POINTER_H__ */
