#ifndef __APPLET_CONTEXTMENU_H__
#define __APPLET_CONTEXTMENU_H__

#include <glib.h>
#include <glib-object.h>
#include "st.h"
#include "cdos-popup-menu.h"
#include "cdos-popup-base-menu-item.h"
#include "cdos-util.h"
#include "applet-menu.h"
#include "applet-generic-application-button.h"
#include "applet-recent-button.h"
#include "applet-button.h"

G_BEGIN_DECLS

#define APPLET_TYPE_CONTEXTMENU                   (applet_contextmenu_get_type ())
#define APPLET_CONTEXTMENU(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_CONTEXTMENU, AppletContextMenu))
#define APPLET_IS_CONTEXEMENU(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_CONTEXTMENU))
#define APPLET_CONTEXTMENU_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_CONTEXTMENU, AppletContextMenuClass))
#define APPLET_IS_CONTEXEMENU_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_CONTEXTMENU))
#define APPLET_CONTEXTMENU_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_CONTEXTMENU, AppletContextMenuClass))

typedef struct _AppletContextMenu AppletContextMenu;
typedef struct _AppletContextMenuPrivate AppletContextMenuPrivate;
typedef struct _AppletContextMenuClass AppletContextMenuClass;

struct _AppletContextMenu 
{

    CdosPopupMenu parent_instance;
    StBoxLayout *actor;
    gfloat x;
    gfloat y;
    AppletContextMenuPrivate *priv;

};

struct _AppletContextMenuClass 
{
    
    CdosPopupMenuClass parent_class;
    
};

GType
applet_contextmenu_get_type(void) G_GNUC_CONST;


CdosPopupMenu *
applet_contextmenu_new(AppletButton *buton);

void
applet_contextmenu_open(CdosPopupMenuBase *obj, gboolean animate);
G_END_DECLS

#endif /* __APPLET_CONTEXTMENU_H__ */
