#ifndef __APPLET_GENERIC_APPLICATION_BUTTON_H__
#define __APPLET_GENERIC_APPLICATION_BUTTON_H__

#include <glib.h>
#include <glib-object.h>
#include "cdos-app.h"
#include "cdos-popup-base-menu-item.h"
#include "applet-menu.h"   //menu完成时再加入
#include "applet-button.h"

G_BEGIN_DECLS

#define APPLET_TYPE_GENERIC_APPLICATION_BUTTON                   (applet_generic_application_button_get_type ())
#define APPLET_GENERIC_APPLICATION_BUTTON(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_GENERIC_APPLICATION_BUTTON, AppletGenericApplicationButton))
#define APPLET_IS_GENERIC_APPLICATION_BUTTON(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_GENERIC_APPLICATION_BUTTON))
#define APPLET_GENERIC_APPLICATION_BUTTON_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_GENERIC_APPLICATION_BUTTON, AppletGenericApplicationButtonClass))
#define APPLET_IS_GENERIC_APPLICATION_BUTTON_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_GENERIC_APPLICATION_BUTTON))
#define APPLET_GENERIC_APPLICATION_BUTTON_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_GENERIC_APPLICATION_BUTTON, AppletGenericApplicationButtonClass))

typedef struct _AppletGenericApplicationButton AppletGenericApplicationButton;
typedef struct _AppletGenericApplicationButtonPrivate AppletGenericApplicationButtonPrivate;
typedef struct _AppletGenericApplicationButtonClass AppletGenericApplicationButtonClass;

struct _AppletGenericApplicationButton 
{
    AppletButton            parent_instance;
    AppletMenu              *applet_button;
    CdosApp                 *app;
    gboolean                with_menu;
    GList                   *menu_items;

};

struct _AppletGenericApplicationButtonClass 
{

    AppletButtonClass       parent_class;
};

GType
applet_generic_application_button_get_type(void) G_GNUC_CONST;

AppletGenericApplicationButton *
applet_generic_application_button_new(void);

void
applet_generic_application_button_constructor(AppletGenericApplicationButton *button, AppletMenu *applet_button, CdosApp *app, gboolean with_menu);

gboolean
applet_generic_application_button_set_active(AppletGenericApplicationButton *self);

void
applet_generic_application_button_activate(AppletGenericApplicationButton *self,  gpointer event, gboolean keep, gpointer data);

void
applet_generic_application_button_close_menu (AppletGenericApplicationButton *generic_application_button);

void
applet_generic_application_button_toggle_menu(AppletGenericApplicationButton *self);

G_END_DECLS

#endif              /* __UI_BOX_POINTER_H__ */
