#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include "st.h"
#include "applet-generic-application-button.h"
#include "applet-menu.h"

#define APPLET_TYPE_SEARCH_RESULT_BUTTON                (applet_search_result_button_get_type ())

#define APPLET_SEARCH_RESULT_BUTTON(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST((obj), APPLET_TYPE_SEARCH_RESULT_BUTTON, AppletSearchResultButton))
	
#define APPLET_IS_SEARCH_RESULT_BUTTON(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_SEARCH_RESULT_BUTTON))

#define APPLET_SEARCH_RESULT_BUTTON_CLASS(klass) \
	(G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_SEARCH_RESULT_BUTTON, AppletSearchResultButtonClass))
	
#define APPLET_IS_SEARCH_RESULT_BUTTON_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_SEARCH_RESULT_BUTTON))

#define APPLET_SEARCH_RESULT_BUTTON_GET_CLASS(obj) \
	(G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_SEARCH_RESULT_BUTTON, AppletSearchResultButtonClass))
	

typedef struct _AppletSearchResultButton AppletSearchResultButton;
typedef struct _AppletSearchResultButtonPrivate AppletSearchResultButtonPrivate;
typedef struct _AppletSearchResultButtonClass AppletSearchResultButtonClass;

/*实例结构*/
struct _AppletSearchResultButton
{
	AppletGenericApplicationButton parent_instance;
	
	ClutterActor *icon;
	StLabel *label;
	
	AppletSearchResultButtonPrivate *priv;
};

/*类结构*/
struct _AppletSearchResultButtonClass
{
	AppletGenericApplicationButtonClass parent_class;
};

GType applet_search_result_button_get_type (void);

AppletSearchResultButton *
applet_search_result_button_new (AppletMenu *apps_menu_button, CdosApp *app);

const gchar *
applet_search_result_button_get_app_id (CdosApp *app);
