//
// Created by cdos on 16-5-13.
//

#ifndef __APPLET_POPUP_SLIDER_V_MENU__H__
#define SLIDER_SCROLL_STEP  0.05 /* Slider scrolling step in % */
#define __APPLET_POPUP_SLIDER_V_MENU__H__

#include <glib-object.h>
#include <gio/gio.h>
#include "ui/cdos-popup-base-menu-item.h"

/*#include "cdos-start.h"*/

#define APPLET_TYPE_POPUP_SLIDER_V_MENU_ITEM            (applet_popup_slider_v_menu_item_get_type ())
#define APPLET_POPUP_SLIDER_V_MENU_ITEM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_POPUP_SLIDER_V_MENU_ITEM, AppletPopupSliderVMenuItem))
#define APPLET_IS_POPUP_SLIDER_V_MENU_ITEM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_POPUP_SLIDER_V_MENU_ITEM))
#define APPLET_POPUP_SLIDER_V_MENU_ITEM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_POPUP_SLIDER_V_MENU_ITEM, AppletPopupSliderVMenuItemClass))
#define APPLET_IS_POPUP_SLIDER_V_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_POPUP_SLIDER_V_MENU_ITEM))
#define APPLET_POPUP_SLIDER_V_MENU_ITEM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_POPUP_SLIDER_V_MENU_ITEM, AppletPopupSliderVMenuItemClass))


typedef struct _AppletPopupSliderVMenuItem AppletPopupSliderVMenuItem;
typedef struct _AppletPopupSliderVMenuItemClass AppletPopupSliderVMenuItemClass;

/* instance structure */
struct _AppletPopupSliderVMenuItem
{
    /*父类*/
    CdosPopupBaseMenuItem parent_instance;

    /*公有成员*/

    /*私有成员*/
    StWidget *p_container;
    StWidget *value_flag;
    StWidget *p_box;
    gfloat p_value;
    gfloat p_slider_height;
    gfloat p_slider_cursor_size;
    StWidget *p_slider;
    gulong p_release_id;
    gulong p_montion_id;
    gboolean p_dragging;

};
/* class structure */
struct _AppletPopupSliderVMenuItemClass
{
    /*父类*/
    CdosPopupBaseMenuItemClass parent_class;

};

GType applet_popup_slider_v_menu_item_get_type(void);

void applet_popup_slider_v_menu_item_set_value(AppletPopupSliderVMenuItem *self, gfloat value);
gfloat applet_popup_slider_v_menu_item_get_value(AppletPopupSliderVMenuItem *self);
AppletPopupSliderVMenuItem * applet_popup_slider_v_menu_item_new(gfloat value);
#endif
