//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialButtons.js

#ifndef __APPLET_APP_BUTTON_H__
#define __APPLET_APP_BUTTON_H__
#include <glib-object.h>
#include <clutter/clutter.h>
#include "applet-icon-label-button.h"
#include "applet-window-list-private.h"
#include "cdos-app.h"
#include "st.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_APP_BUTTON (applet_app_button_get_type())
//强制类型转换;
#define APPLET_APP_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APP_BUTTON,AppletAppButton))
//检测类型实例
#define APPLET_IS_APP_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APP_BUTTON))
//类型转换(可选)
#define APPLET_APP_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APP_BUTTON,AppletAppButtonClass))
//检测是否是类的成员(可选)
#define APPLET_IS_APP_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APP_BUTTON))
//获取实例对象的类结构(可选)
#define APPLET_APP_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_APP_BUTTON,AppletAppButtonClass))

//定义对象实例
//typedef struct _AppletAppButton AppletAppButton;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletAppButtonClass AppletAppButtonClass;

typedef struct _AppletAppButtonPrivate AppletAppButtonPrivate;

struct _AppletAppButton {
    AppletIconLabelButton parent;
    /*private*/
    AppletAppButtonPrivate *priv;
};
struct _AppletAppButtonClass {
    AppletIconLabelButtonClass parent_class;
};
//取得对象类型ID;
GType	applet_app_button_get_type(void);
//创建对象实例;
AppletAppButton*  applet_app_button_new(AppletAppGroup *parent);

//对象的属性成员方法列表;

void applet_app_button_destroy(AppletAppButton *self);

void applet_app_button_is_favorite(AppletAppButton *self,gboolean is_favorite);


//getter and setter functions;
gint applet_app_button_get_icon_size(AppletAppButton *self);
ClutterActor* applet_app_button_get_icon(AppletAppButton *self);
gboolean applet_app_button_get_is_favorite_app(AppletAppButton *self);
void applet_app_button_update_actor_style(AppletAppButton *self);

#endif //__APPLET_APP_BUTTON_H__
