//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialMenus.js

#ifndef __APPLET_APP_CONTEXT_MENU_H__
#define __APPLET_APP_CONTEXT_MENU_H__
#include <glib-object.h>
#include <meta/window.h>
#include <clutter/clutter.h>
#include "cdos-popup-menu.h"
#include "applet-window-list-private.h"
#include "cdos-app.h"
#include "st.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_APP_CONTEXT_MENU (applet_app_context_menu_get_type())
//强制类型转换;
#define APPLET_APP_CONTEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APP_CONTEXT_MENU,AppletAppContextMenu))
//检测类型实例
#define APPLET_IS_APP_CONTEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APP_CONTEXT_MENU))
//类型转换(可选)
#define APPLET_APP_CONTEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APP_CONTEXT_MENU,AppletAppContextMenuClass))
//检测是否是类的成员(可选)
#define APPLET_IS_APP_CONTEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APP_CONTEXT_MENU))
//获取实例对象的类结构(可选)
#define APPLET_APP_CONTEXT_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_APP_CONTEXT_MENU,AppletAppContextMenuClass))

//定义对象实例
//typedef struct _AppletAppContextMenu AppletAppContextMenu;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletAppContextMenuClass AppletAppContextMenuClass;

typedef struct _AppletAppContextMenuPrivate AppletAppContextMenuPrivate;

typedef struct _AppletAppContextMenuParams AppletAppContextMenuParams;

struct _AppletAppContextMenu {
    CdosPopupMenu parent;
    /*private*/
    AppletAppContextMenuPrivate *priv;
};
struct _AppletAppContextMenuClass {
    CdosPopupMenuClass parent_class;

};

struct _AppletAppContextMenuParams{
    StWidget *actor;
    StWidget *parent_actor;
    StSide orientation;
    MetaWindow *meta_window;
    CdosApp *app;
    gboolean is_favorite_app;
    AppletWindowList *applet;
    AppletAppGroup *app_group;
};

//取得对象类型ID;
GType	applet_app_context_menu_get_type(void);
//创建对象实例;
AppletAppContextMenu*  applet_app_context_menu_new(AppletAppContextMenuParams *params);

//对象的属性成员方法列表;
void applet_app_context_menu_remove_items(AppletAppContextMenu *self);

void applet_app_context_menu_destroy(AppletAppContextMenu *self);

void applet_app_context_menu_set_meta_window(AppletAppContextMenu *self,MetaWindow *meta_window);

void applet_app_context_menu_is_favorite(AppletAppContextMenu *self,gboolean is_added);

//getter and setter functions;
MetaWindow* applet_app_context_menu_get_meta_window(AppletAppContextMenu *self);

CdosApp* applet_app_context_menu_get_app(AppletAppContextMenu *self);

GList* applet_app_context_menu_get_windows(AppletAppContextMenu *self);

gchar * applet_app_context_menu_get_app_id(AppletAppContextMenu *self);

gboolean applet_app_context_menu_get_open_state(AppletAppContextMenu *self);

#endif //__APPLET_APP_CONTEXT_MENU_H__
