//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#ifndef __APPLET_APP_LIST_H__
#define __APPLET_APP_LIST_H__
#include <glib-object.h>
#include <meta/workspace.h>
#include "applet-window-list-private.h"
#include "cdos-app.h"
#include "st.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_APP_LIST (applet_app_list_get_type())
//强制类型转换;
#define APPLET_APP_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APP_LIST,AppletAppList))
//检测类型实例
#define APPLET_IS_APP_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APP_LIST))
//类型转换(可选)
#define APPLET_APP_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APP_LIST,AppletAppListClass))
//检测是否是类的成员(可选)
#define APPLET_IS_APP_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APP_LIST))
//获取实例对象的类结构(可选)
#define APPLET_APP_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_APP_LIST,AppletAppListClass))

//定义对象实例
//typedef struct _AppletAppList AppletAppList;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletAppListClass AppletAppListClass;

typedef struct _AppletAppListClassPrivate AppletAppListClassPrivate;
typedef struct _AppletAppListPrivate AppletAppListPrivate;

struct _AppletAppList {
    GObject parent;
    /*private*/
    AppletAppListPrivate *priv;
};
struct _AppletAppListClass {
    /*
    void (*app_group_count_change) ();
    void (*page_size_change)();
     */
    GObjectClass parent_class;
};
//取得对象类型ID;
GType	applet_app_list_get_type(void);
//创建对象实例;
AppletAppList*  applet_app_list_new(AppletWindowList *applet,MetaWorkspace *meta_workspace,StSide orientation);

//对象的属性成员方法列表;
void applet_app_list_destroy(AppletAppList *self);

void applet_app_list_refresh_apps(AppletAppList *self);

void applet_app_list_refresh(AppletAppList *self);

//getter and setter functions;
AppletWindowListBox* applet_app_list_get_my_actor_box(AppletAppList *self);

StWidget* applet_app_list_get_actor(AppletAppList *self);

guint applet_app_list_get_page_size(AppletAppList *self);

gboolean applet_app_list_set_page_size(AppletAppList *self,guint page_size);

MetaWorkspace* applet_app_list_get_meta_workspace(AppletAppList *self);

void applet_app_list_add_pagination(AppletAppList *self);

void applet_app_list_remove_pagination(AppletAppList *self);

guint applet_app_list_get_workspace_index(AppletAppList *self);




#endif //__APPLET_APP_LIST_H__
