//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialButtons.js

#ifndef __APPLET_ICON_LABEL_BUTTON_H__
#define __APPLET_ICON_LABEL_BUTTON_H__
#include <glib-object.h>
#include "applet-window-list-private.h"
#include "cdos-generic-container.h"
#include "st.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_ICON_LABEL_BUTTON (applet_icon_label_button_get_type())
//强制类型转换;
#define APPLET_ICON_LABEL_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_ICON_LABEL_BUTTON,AppletIconLabelButton))
//检测类型实例
#define APPLET_IS_ICON_LABEL_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_ICON_LABEL_BUTTON))
//类型转换(可选)
#define APPLET_ICON_LABEL_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_ICON_LABEL_BUTTON,AppletIconLabelButtonClass))
//检测是否是类的成员(可选)
#define APPLET_IS_ICON_LABEL_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_ICON_LABEL_BUTTON))
//获取实例对象的类结构(可选)
#define APPLET_ICON_LABEL_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_ICON_LABEL_BUTTON,AppletIconLabelButtonClass))

//定义对象实例
//typedef struct _AppletIconLabelButton AppletIconLabelButton;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletIconLabelButtonClass AppletIconLabelButtonClass;

typedef struct _AppletIconLabelButtonPrivate AppletIconLabelButtonPrivate;

struct _AppletIconLabelButton {
    GObject parent;
    AppletIconLabelButtonPrivate *priv;
};
struct _AppletIconLabelButtonClass {
    GObjectClass parent_class;
};
//取得对象类型ID;
GType	applet_icon_label_button_get_type(void);
//创建对象实例;
//该类只作为其他类的父类，不提供实例化
//AppletIconLabelButton*  applet_icon_label_button_new(AppletAppGroup *parent);
void applet_icon_label_button_constructor(AppletIconLabelButton *self,AppletWindowList *applet,ClutterActor *icon);

//对象的属性成员方法列表;
void applet_icon_label_button_set_icon_padding(AppletIconLabelButton *self);

void applet_icon_label_button_set_text(AppletIconLabelButton *self,gchar *text);

void applet_icon_label_button_set_style(AppletIconLabelButton *self,gchar *name);

void applet_icon_label_button_icon_sink(AppletIconLabelButton *self,gint size);

void applet_icon_label_button_icon_recovery(AppletIconLabelButton *self);

void applet_icon_label_button_show(AppletIconLabelButton *self,gboolean animate,gfloat target_width);

void applet_icon_label_button_hide(AppletIconLabelButton *self,gboolean animate);

void applet_icon_label_button_show_label(AppletIconLabelButton *self,gboolean animate,gfloat target_width);

void applet_icon_label_button_hide_label(AppletIconLabelButton *self,gboolean animate);

void applet_icon_label_button_destroy(AppletIconLabelButton *self);

//getter and setter functions;
StWidget* applet_icon_label_button_get_actor(AppletIconLabelButton *self);

CdosGenericContainer* applet_icon_label_button_get_container(AppletIconLabelButton *self);

StWidget* applet_icon_label_button_get_num_label(AppletIconLabelButton *self);

void applet_icon_label_button_set_num_label_text(AppletIconLabelButton *self,gchar *text);

StWidget* applet_icon_label_button_get_label(AppletIconLabelButton *self);

void applet_icon_label_button_set_label_text(AppletIconLabelButton *self,gchar *text);

gfloat applet_icon_label_button_get_icon_modification_x(AppletIconLabelButton *self);

void applet_icon_label_button_set_icon_modification_x(AppletIconLabelButton *self,gfloat value);


#endif //__APPLET_ICON_LABEL_BUTTON_H__
