//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#ifndef __APPLET_PINNED_FAVS_H__
#define __APPLET_PINNED_FAVS_H__
#include <glib-object.h>
#include "applet-window-list-private.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_PINNED_FAVS (applet_pinned_favs_get_type())
//强制类型转换;
#define APPLET_PINNED_FAVS(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_PINNED_FAVS,AppletPinnedFavs))
//检测类型实例
#define APPLET_IS_PINNED_FAVS(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_PINNED_FAVS))
//类型转换(可选)
#define APPLET_PINNED_FAVS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_PINNED_FAVS,AppletPinnedFavsClass))
//检测是否是类的成员(可选)
#define APPLET_IS_PINNED_FAVS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_PINNED_FAVS))
//获取实例对象的类结构(可选)
#define APPLET_PINNED_FAVS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_PINNED_FAVS,AppletPinnedFavsClass))

//定义对象实例
//typedef struct _AppletPinnedFavs AppletPinnedFavs;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletPinnedFavsClass AppletPinnedFavsClass;

typedef struct _AppletPinnedFavsPrivate AppletPinnedFavsPrivate;

struct _AppletPinnedFavs {
    GObject parent;
    AppletPinnedFavsPrivate *priv;
};
struct _AppletPinnedFavsClass {
    GObjectClass parent_class;

};
//取得对象类型ID;
GType	applet_pinned_favs_get_type(void);
//创建对象实例;
AppletPinnedFavs*  applet_pinned_favs_new(AppletWindowList *applet);

//对象的属性成员方法列表;
GList* applet_pinned_favs_get_favorite_map(AppletPinnedFavs *self);

void applet_pinned_favs_get_favorites(AppletPinnedFavs *self,GList *favorites);

gboolean applet_pinned_favs_is_favorite(AppletPinnedFavs *self,gchar *app_id);

void applet_pinned_favs_add_favorite_at_pos(AppletPinnedFavs *self,gchar *app_id,gint pos);

void applet_pinned_favs_add_favorite(AppletPinnedFavs *self,gchar *app_id);

void applet_pinned_favs_remove_favorite(AppletPinnedFavs *self,gchar *app_id);

void applet_pinned_favs_move_favorite_to_pos(AppletPinnedFavs *self,gchar *app_id,gint pos);

//对象信息;
void  applet_pinned_favs_info(AppletPinnedFavs *self);



#endif //__APPLET_PINNED_FAVS_H__
