//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialButtons.js

#ifndef __APPLET_WINDOW_BUTTON_H__
#define __APPLET_WINDOW_BUTTON_H__
#include <glib-object.h>
#include <meta/window.h>
#include <clutter/clutter.h>

#include "cdos-app.h"
#include "applet-icon-label-button.h"
#include "applet-window-list-private.h"
#include "applet-app-list.h"
#include "applet-app-context-menu.h"


//直接取得并替代对象ID标示符;
#define APPLET_TYPE_WINDOW_BUTTON (applet_window_button_get_type())
//强制类型转换;
#define APPLET_WINDOW_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_WINDOW_BUTTON,AppletWindowButton))
//检测类型实例
#define APPLET_IS_WINDOW_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_WINDOW_BUTTON))
//类型转换(可选)
#define APPLET_WINDOW_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_WINDOW_BUTTON,AppletWindowButtonClass))
//检测是否是类的成员(可选)
#define APPLET_IS_WINDOW_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_WINDOW_BUTTON))
//获取实例对象的类结构(可选)
#define APPLET_WINDOW_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_WINDOW_BUTTON,AppletWindowButtonClass))

//定义对象实例
//typedef struct _AppletWindowButton AppletWindowButton;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletWindowButtonClass AppletWindowButtonClass;

typedef struct _AppletWindowButtonPrivate AppletWindowButtonPrivate;

typedef struct _AppletWindowButtonParams AppletWindowButtonParams;

struct _AppletWindowButton {
    AppletIconLabelButton parent;
    AppletWindowButtonPrivate *priv;
};
struct _AppletWindowButtonClass {
    AppletIconLabelButtonClass parent_class;
};

struct _AppletWindowButtonParams{
    gboolean is_favorite_app;
    StSide orientation;
    MetaWindow *meta_window;
    AppletWindowList *applet;
    AppletAppList *app_list;
    CdosApp *app;

};

//取得对象类型ID;
GType	applet_window_button_get_type(void);
//创建对象实例;
AppletWindowButton*  applet_window_button_new(AppletWindowButtonParams *params);
void applet_window_button_constructor(AppletWindowButton *self,AppletWindowButtonParams *params);

//对象的属性成员方法列表;
void applet_window_button_destroy(AppletWindowButton *self);

gboolean applet_window_button_handle_drag_over(AppletWindowButton *self,AppletWindowButton *source,ClutterActor *actor,gint x,gint y,gint time);

gboolean applet_window_button_accept_drop(AppletWindowButton *self,AppletWindowButton *source,ClutterActor *actor,gint x,gint y,gint time);

//getter and setter functions;
AppletAppList* applet_window_button_get_app_list(AppletWindowButton *self);

MetaWindow* applet_window_button_get_meta_window(AppletWindowButton *self);

void applet_window_button_set_meta_window(AppletWindowButton *self,MetaWindow* meta_window);

CdosApp* applet_window_button_get_app(AppletWindowButton *self);

gboolean applet_window_button_get_is_favorite_app(AppletWindowButton *self);

void applet_window_button_set_is_favorite_app(AppletWindowButton *self,gboolean is_favorite_app);

ClutterActor* applet_window_button_get_icon(AppletWindowButton *self);

gint applet_window_button_get_icon_size(AppletWindowButton *self);

void applet_window_button_set_icon_size(AppletWindowButton *self,gint icon_size);






#endif //__APPLET_WINDOW_BUTTON_H__
