//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js
// 原类名是MyAppletBox

#ifndef __APPLET_WINDOW_LIST_BOX_H__
#define __APPLET_WINDOW_LIST_BOX_H__
#include <glib-object.h>
#include "applet-window-list-private.h"
#include "st.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_WINDOW_LIST_BOX (applet_window_list_box_get_type())
//强制类型转换;
#define APPLET_WINDOW_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_WINDOW_LIST_BOX,AppletWindowListBox))
//检测类型实例
#define APPLET_IS_WINDOW_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_WINDOW_LIST_BOX))
//类型转换(可选)
#define APPLET_WINDOW_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_WINDOW_LIST_BOX,AppletWindowListBoxClass))
//检测是否是类的成员(可选)
#define APPLET_IS_WINDOW_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_WINDOW_LIST_BOX))
//获取实例对象的类结构(可选)
#define APPLET_WINDOW_LIST_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_WINDOW_LIST_BOX,AppletWindowListBoxClass))

//定义对象实例
//typedef struct _AppletWindowListBox AppletWindowListBox;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletWindowListBoxClass AppletWindowListBoxClass;

typedef struct _AppletWindowListBoxPrivate AppletWindowListBoxPrivate;

struct _AppletWindowListBox {
    GObject parent;

    AppletWindowListBoxPrivate *priv;
};
struct _AppletWindowListBoxClass {
    GObjectClass parent_class;

};
//取得对象类型ID;
GType	applet_window_list_box_get_type(void);
//创建对象实例;
AppletWindowListBox*  applet_window_list_box_new(AppletWindowList *applet);

//对象的属性成员方法列表;



//私有转公有 ;
void applet_window_list_box_clear_drag_place_holder(AppletWindowListBox *self);

//getter and setter functions;
StWidget* applet_window_list_box_get_actor(AppletWindowListBox *self);



#endif //__APPLET_WINDOW_LIST_BOX_H__
