//
// Created by zhangtao on 16-3-15.
// source:applets/window-list*/specialButtons.js

//添加依赖;
#include "applet-window-list-draggable.h"


/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletWindowListDraggablePrivate{

};

/*-------global variables-------------*/
static gint AppletWindowListDraggable_private_offset = 0;
static gint applet_window_list_draggable_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_window_list_draggable_parent_class = NULL;



/*-------class functions---------*/
static void applet_window_list_draggable_init(AppletWindowListDraggable *self);
static void applet_window_list_draggable_class_init(AppletWindowListDraggableClass *klass);

static void applet_window_list_draggable_dispose(GObject *object);
static void applet_window_list_draggable_finalize(GObject *object);

/*-------------private functions of instance-------------------*/

static AppletWindowListDraggable*  applet_window_list_draggable_new(ClutterActor *actor);

/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_window_list_draggable_get_type(void)
{
    static GType applet_window_list_draggable_type = 0;
    if(G_UNLIKELY(applet_window_list_draggable_type==0))
    {
        static const GTypeInfo applet_window_list_draggable_info = {
                sizeof(AppletWindowListDraggableClass),
                NULL,NULL,
                (GClassInitFunc)applet_window_list_draggable_class_init,
                NULL,NULL,
                sizeof(AppletWindowListDraggable),
                0,
                (GInstanceInitFunc)applet_window_list_draggable_init
        };
        //类注册
        applet_window_list_draggable_type = g_type_register_static(CDOS_TYPE_DRAGGABLE,"AppletWindowListDraggable",&applet_window_list_draggable_info,0);
        //g_type_add_class_private(applet_window_list_draggable_type, sizeof(AppletWindowListDraggableClassPrivate));
        AppletWindowListDraggable_private_offset =
                g_type_add_instance_private(applet_window_list_draggable_type, sizeof(AppletWindowListDraggablePrivate));

    }
    return applet_window_list_draggable_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_window_list_draggable_get_instance_private(AppletWindowListDraggable *self){
    return (G_STRUCT_MEMBER_P (self, AppletWindowListDraggable_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_window_list_draggable_init(AppletWindowListDraggable *self)
{
    AppletWindowListDraggablePrivate *priv;
    self->priv=applet_window_list_draggable_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/


}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_window_list_draggable_class_init(AppletWindowListDraggableClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletWindowListDraggable_private_offset);
    applet_window_list_draggable_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_window_list_draggable_constructed;
    gobject_class->dispose=applet_window_list_draggable_dispose;
    gobject_class->finalize=applet_window_list_draggable_finalize;

    /*-------------类方法注册---------------*/
    //示例：klass->monitors_changed=applet_window_list_draggable_monitors_changed;


    /*-------------信号注册---------------*/

}

/*------------类方法定义-----------*/
static void applet_window_list_draggable_dispose(GObject *object){
    AppletWindowListDraggable *self = APPLET_WINDOW_LIST_DRAGGABLE(object);
    AppletWindowListDraggablePrivate *priv = self->priv;



    G_OBJECT_CLASS(applet_window_list_draggable_parent_class)->dispose(object);
};

static void applet_window_list_draggable_finalize(GObject *object){
    AppletWindowListDraggable *self = APPLET_WINDOW_LIST_DRAGGABLE(object);
    AppletWindowListDraggablePrivate *priv = self->priv;

    G_OBJECT_CLASS(applet_window_list_draggable_parent_class)->finalize(object);
};

/*-------------private functions--------------*/




/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
static AppletWindowListDraggable* applet_window_list_draggable_new(ClutterActor *actor)
{
    // g_print("\nDebug:File = %s >> Func = %s >> Line = %d\n",__FILE__,__func__,__LINE__);
    AppletWindowListDraggable *self;
    self = g_object_new(APPLET_TYPE_WINDOW_LIST_DRAGGABLE, NULL);
    return self;
}

AppletWindowListDraggable*  applet_window_list_draggable_make(ClutterActor *actor){
    // g_print("\nDebug:File = %s >> Func = %s >> Line = %d\n",__FILE__,__func__,__LINE__);
    AppletWindowListDraggable *self = applet_window_list_draggable_new(actor);
    return self;
};
