//
// Created by zhangtao on 16-3-15.
// source:applets/window-list*/specialButtons.js

#ifndef __APPLET_WINDOW_LIST_DRAGGABLE_H__
#define __APPLET_WINDOW_LIST_DRAGGABLE_H__

#include <glib-object.h>
#include <clutter/clutter.h>
#include "cdos-dnd.h"
#include "applet-window-list-private.h"
//直接取得并替代对象ID标示符;
#define APPLET_TYPE_WINDOW_LIST_DRAGGABLE (applet_window_list_draggable_get_type())
//强制类型转换;
#define APPLET_WINDOW_LIST_DRAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_WINDOW_LIST_DRAGGABLE,AppletWindowListDraggable))
//检测类型实例
#define APPLET_IS_WINDOW_LIST_DRAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_WINDOW_LIST_DRAGGABLE))
//类型转换(可选)
#define APPLET_WINDOW_LIST_DRAGGABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_WINDOW_LIST_DRAGGABLE,AppletWindowListDraggableClass))
//检测是否是类的成员(可选)
#define APPLET_IS_WINDOW_LIST_DRAGGABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_WINDOW_LIST_DRAGGABLE))
//获取实例对象的类结构(可选)
#define APPLET_WINDOW_LIST_DRAGGABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_WINDOW_LIST_DRAGGABLE,AppletWindowListDraggableClass))

//定义对象实例
//typedef struct _AppletWindowListDraggable AppletWindowListDraggable;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletWindowListDraggableClass AppletWindowListDraggableClass;

typedef struct _AppletWindowListDraggablePrivate AppletWindowListDraggablePrivate;

struct _AppletWindowListDraggable {
    CdosDraggable parent;
    AppletWindowListDraggablePrivate *priv;
};
struct _AppletWindowListDraggableClass {
    CdosDraggableClass parent_class;

};
//取得对象类型ID;
GType	applet_window_list_draggable_get_type(void);
//创建对象实例;


AppletWindowListDraggable*  applet_window_list_draggable_make(ClutterActor *actor);



//对象的属性成员方法列表;


#endif //__APPLET_WINDOW_LIST_DRAGGABLE_H__
