//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js
// 原类名：MyApplet
#ifndef __APPLET_WINDOW_LIST_H__
#define __APPLET_WINDOW_LIST_H__

#include <glib-object.h>
#include <meta/workspace.h>
#include "cdos-applet-settings.h"
#include "applet-window-list-private.h"
#include "cdos.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_WINDOW_LIST (applet_window_list_get_type())
//强制类型转换;
#define APPLET_WINDOW_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_WINDOW_LIST,AppletWindowList))
//检测类型实例
#define APPLET_IS_WINDOW_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_WINDOW_LIST))
//类型转换(可选)
#define APPLET_WINDOW_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_WINDOW_LIST,AppletWindowListClass))
//检测是否是类的成员(可选)
#define APPLET_IS_WINDOW_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_WINDOW_LIST))
//获取实例对象的类结构(可选)
#define APPLET_WINDOW_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_WINDOW_LIST,AppletWindowListClass))

//定义对象实例
///typedef struct _AppletWindowList AppletWindowList;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletWindowListClass AppletWindowListClass;

typedef struct _AppletWindowListPrivate AppletWindowListPrivate;


struct _AppletWindowList {
    CdosApplet parent;
    AppletWindowListPrivate *priv;
};
struct _AppletWindowListClass {
    CdosAppletClass parent_class;

};
//取得对象类型ID;
GType	applet_window_list_get_type(void);
//创建对象实例;需要转为私有
//AppletWindowList*  applet_window_list_new(CdosMetadata *metadata,StSide orientation,gint panel_height,gchar *instance_id);

//对象的属性成员方法列表;

AppletPinnedFavs* applet_window_list_spinned_app_contr(AppletWindowList *self);

void applet_window_list_destroy(AppletWindowList *self);

gfloat applet_window_list_get_panel_height(AppletWindowList *self);

//applet入口函数；
CdosApplet* applets_window_list_main(MetaData *metadata,StSide orientation,gfloat panel_height,gchar *instance_id);

//getter and setter functions;
CdosAppletSettings* applet_window_list_get_settings(AppletWindowList *self);

StWidget* applet_window_list_get_actor(AppletWindowList *self);

gboolean applet_window_list_get_drag_in_progress(AppletWindowList *self);

void applet_window_list_set_drag_in_progress(AppletWindowList *self,gboolean drag_in_progress);

AppletPinnedFavs* applet_window_list_get_pinned_apps_contr(AppletWindowList *self);

StSide applet_window_list_get_orientation(AppletWindowList *self);


#endif //__APPLET_WINDOW_LIST_H__
