/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_ARROW_H__
#define __CDOS_ARROW_H__

#include <clutter/clutter.h>
#include <gtk/gtk.h>

#define CDOS_TYPE_ARROW                 (cdos_arrow_get_type ())
#define CDOS_ARROW(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_ARROW, CdosArrow))
#define CDOS_ARROW_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_ARROW, CdosArrowClass))
#define CDOS_IS_ARROW(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_ARROW))
#define CDOS_IS_ARROW_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_ARROW))
#define CDOS_ARROW_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_ARROW, CdosArrowClass))

typedef struct _CdosArrow        CdosArrow;
typedef struct _CdosArrowClass   CdosArrowClass;

typedef struct _CdosArrowPrivate CdosArrowPrivate;

struct _CdosArrow
{
    ClutterCairoTexture parent;

    CdosArrowPrivate *priv;
};

struct _CdosArrowClass
{
    ClutterCairoTextureClass parent_class;
};

GType cdos_arrow_get_type (void) G_GNUC_CONST;

#endif /* __CDOS_ARROW_H__ */
