#include "cdos_session_dbus.h"
#include "cdos-session.h"

static gboolean
on_handle_open (Xunli *skeleton,
		     GDBusMethodInvocation *invocation,
  		     guint type, 
		     guint zero, 
		     guint timeout,
		     gchar *gvar)
{
  g_print ("get variant value: \n");
  GVariant *value;

 // g_variant_get (gvar, "as", &value);

  g_print ("type is %d, zero is %d, timeout is %d\n", type, zero, timeout);
/*  GVariantIter *iter;
  g_print ("%s %d, 0x%x\n", __func__, __LINE__, gvar);
  g_variant_get (gvar, "as", &iter);
  g_print ("%s %d\n", __func__, __LINE__);
  gchar *path;
  while (g_variant_iter_loop (iter, "s", &path)){
  	g_print ("%s %d\n", __func__, __LINE__);
  	g_print ("path is %s\n", path);
  }

  g_variant_iter_free (iter);*/
  g_print ("path is %s\n", gvar);
  switch (type){
  	case 0:
		g_print ("logout\n");
		first_dialog ();
		break;
	case 1:
		g_print ("reboot\n");
		break;
	case 2:
		g_print ("shutdown\n");
		break;
	default:
		g_print ("a ...\n");
		break;
  
  }
  xunli_complete_open (skeleton, invocation);
}

static void
on_name_acquired (GDBusConnection *connection,
		  const gchar *name,
		  gpointer user_data)
{
  Xunli *skeleton;

  skeleton = xunli_skeleton_new ();
  g_signal_connect (skeleton,
		    "handle-open",
		    G_CALLBACK (on_handle_open),
		    NULL);

  g_dbus_interface_skeleton_export (G_DBUS_INTERFACE_SKELETON (skeleton),
				    connection,
				    "/org/Cdos/Xunli",
				    NULL);
}

/*void main (void)
{
  GMainLoop *loop;

  loop = g_main_loop_new (NULL, FALSE);

  g_bus_own_name (G_BUS_TYPE_SESSION,
		  "org.Cdos.Xunli",
		  G_BUS_NAME_OWNER_FLAGS_NONE,
		  NULL,
		  on_name_acquired,
		  NULL,
		  NULL,
		  NULL);

  g_main_loop_run (loop);
}*/

