#ifndef __CDOS_DESKLET_SETTINGS_H__
#define __CDOS_DESKLET_SETTINGS_H__

#include "st.h"
#include "cdos-provider.h"

G_BEGIN_DECLS

#define CDOS_TYPE_DESKLET_SETTINGS  (cdos_desklet_settings_get_type())

#define CDOS_DESKLET_SETTINGS(obj)  \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_DESKLET_SETTINGS, CdosDeskletSettings))

#define CDOS_IS_DESKLET_SETTINGS(obj) \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_DESKLET_SETTINGS))

#define CDOS_DESKLET_SETTINGS_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_DESKLET_SETTINGS, CdosDeskletSettingsClass))

#define CDOS_IS_DESKLET_SETTINGS_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_DESKLET_SETTINGS ))

#define CDOS_DESKLET_SETTINGS_GET_CLASS(obj) \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_DESKLET_SETTINGS, CdosDeskletSettingsClass ))

typedef struct _CdosDeskletSettings CdosDeskletSettings;
typedef struct _CdosDeskletSettingsPrivate CdosDeskletSettingsPrivate;
typedef struct _CdosDeskletSettingsClass CdosDeskletSettingsClass;


struct _CdosDeskletSettings
{
    CdosProvider parent_instance;
};

struct _CdosDeskletSettingsClass
{
    CdosProviderClass parent_class;
};


GType cdos_desklet_settings_get_type(void) G_GNUC_CONST;

CdosDeskletSettings *
cdos_desklet_settings_new(GObject *xlet, const gchar *uuid, gchar *instanceId);

gboolean 
cdos_desklet_settings_get_is_multi_instance_xlet(CdosDeskletSettings *settings,
                                                                                const gchar *uuid);

G_END_DECLS

#endif /*__CDOS_DESKLET_SETTINGS_H__*/
