
#ifndef __CDOS_EXPO_H__
#define __CDOS_EXPO_H__

#include <glib-object.h>



GType	cdos_expo_get_type (void);


#define CDOS_TYPE_EXPO (cdos_expo_get_type())
#define CDOS_EXPO(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_EXPO,CdosExpo))
#define CDOS_IS_EXPO(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_EXPO))
#define CDOS_EXPO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_EXPO,CdosExpoClass))
#define CDOS_IS_EXPO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_EXPO))
#define CDOS_EXPO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_EXPO,CdosExpoClass))

typedef struct _CdosExpo CdosExpo;
typedef struct _CdosExpoClass CdosExpoClass;
typedef struct _CdosExpoPrivate CdosExpoPrivate;


struct _CdosExpo {

    GObject parent;
    CdosExpoPrivate *priv;
};


struct _CdosExpoClass {

    GObjectClass parent_class;
/*    void (*destroy)(CdosExpo *instance);
    void (*shown)(CdosExpo *instance);
    void (*showing)(CdosExpo *instance);
    void (*hiding)(CdosExpo *instance);
    void (*hidden)(CdosExpo *instance); */
};


//公有函数

CdosExpo*  cdos_expo_new (void);

void  cdos_expo_hide (CdosExpo *self,gboolean options);

void  cdos_expo_show (CdosExpo *self);

void  cdos_expo_toggle (CdosExpo *self);

//getter and setter functions;
gboolean cdos_expo_get_animation_in_progress (CdosExpo *self);

void cdos_expo_set_animation_in_progress (CdosExpo *self,gboolean animation);

gboolean cdos_expo_get_visible (CdosExpo *self);

void cdos_expo_set_visible (CdosExpo *self,gboolean visible);

#endif //__CDOS_EXPO_H__
