//
// Created by zhangtao on 16-7-04.
// source:keyboard.js:Key

#ifndef __CDOS_KEY_H__
#define __CDOS_KEY_H__
#include "cdos-keyboard-private.h"
//直接取得并替代对象ID标示符;
#define CDOS_TYPE_KEY (cdos_key_get_type())
//强制类型转换;
#define CDOS_KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_KEY,CdosKey))
//检测类型实例
#define CDOS_IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_KEY))
//类型转换(可选)
#define CDOS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_KEY,CdosKeyClass))
//检测是否是类的成员(可选)
#define CDOS_IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_KEY))
//获取实例对象的类结构(可选)
#define CDOS_KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_KEY,CdosKeyClass))

//定义对象实例
typedef struct _CdosKeyPrivate CdosKeyPrivate;
//定义对象的类结构，全部对象实例所共有；
typedef struct _CdosKeyClass CdosKeyClass;

struct _CdosKey {
    GObject parent;
    CdosKeyPrivate *priv;
};
struct _CdosKeyClass {
    GObjectClass parent_class;
};

//取得对象类型ID;
GType	cdos_key_get_type(void);
//创建对象实例;
CdosKey*  cdos_key_new(CaribouKeyModel *key);

StWidget*  cdos_key_get_actor(CdosKey *self);

StWidget*  cdos_key_get_actor_extended_keys(StWidget *actor);

gdouble* cdos_key_get_button_key_width(StWidget *button);

CaribouKeyModel *cdos_key_get_key_extended_key(StWidget *key);



#endif //__CDOS_KEY_H__
