//
// Created by zhangtao on 16-7-5.
// source:keyboard.js:KeyboardSource

#ifndef __CDOS_KEYBOARD_SOURCE_H__
#define __CDOS_KEYBOARD_SOURCE_H__
#include "cdos-keyboard-private.h"
#include "cdos-source.h"
//直接取得并替代对象ID标示符;
#define CDOS_TYPE_KEYBOARD_SOURCE (cdos_keyboard_source_get_type())
//强制类型转换;
#define CDOS_KEYBOARD_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_KEYBOARD_SOURCE,CdosKeyboardSource))
//检测类型实例
#define CDOS_IS_KEYBOARD_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_KEYBOARD_SOURCE))
//类型转换(可选)
#define CDOS_KEYBOARD_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_KEYBOARD_SOURCE,CdosKeyboardSourceClass))
//检测是否是类的成员(可选)
#define CDOS_IS_KEYBOARD_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_KEYBOARD_SOURCE))
//获取实例对象的类结构(可选)
#define CDOS_KEYBOARD_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_KEYBOARD_SOURCE,CdosKeyboardSourceClass))

//定义对象实例
typedef struct _CdosKeyboardSourcePrivate CdosKeyboardSourcePrivate;
//定义对象的类结构，全部对象实例所共有；
typedef struct _CdosKeyboardSourceClass CdosKeyboardSourceClass;

struct _CdosKeyboardSource {
    CdosSource parent;
    CdosKeyboardSourcePrivate *priv;
};
struct _CdosKeyboardSourceClass {
    CdosSourceClass parent_class;
};

//取得对象类型ID;
GType	cdos_keyboard_source_get_type(void);
//创建对象实例;
CdosKeyboardSource*  cdos_keyboard_source_new(CdosKeyboard *keyboard);

StWidget* cdos_keyboard_source_create_notification_icon(CdosKeyboardSource *self);

gboolean cdos_keyboard_source_handle_summary_click(CdosKeyboardSource *self);

void cdos_keyboard_source_open(CdosKeyboardSource *self);

//对象的属性成员方法列表;

#endif //__CDOS_KEYBOARD_SOURCE_H__
