#include "cdos.h"
#include "cdos-test.h"

CdosApplet *
cdos_test_sunny_applet_new (MetaData *meta, StSide orientation,
                                      gfloat panel_height,
                                      gchar * applet_id){

    cdos_debug ();
    //CdosApplet *applet = cdos_applet_new (orientation, panel_height, applet_id);
    CdosApplet *applet = g_object_new(CDOS_TYPE_APPLET,NULL);
    StBoxLayout *applet_actor = cdos_applet_get_actor (applet);

    StIcon *icon = st_icon_new ();
    st_icon_set_icon_name (icon , "sunny");
    StIconType type = ST_ICON_FULLCOLOR;
    st_icon_set_icon_type (icon, type);

    StBin *abin = st_bin_new ();
    st_container_add_actor ((ClutterContainer *)applet_actor, abin);

    clutter_actor_set_reactive ((ClutterActor *)icon, TRUE);
    st_widget_set_track_hover ((StWidget *)icon, TRUE);
    st_widget_set_style_class_name ((StWidget *)icon, "applet-icon");
    st_bin_set_child (abin, icon);
    cdos_debug ();
    return applet;
    // 还差最后一步，将 applet_actor 添加到 panel 的box 中，尝试交给 AM 来实现
}
