#ifndef __CDOS_WORKSPACES_VIEW_H__
#define __CDOS_WORKSPACES_VIEW_H__

#include "cdos-global.h"
#include "st.h"
#include "cdos.h"

#define CDOS_TYPE_WORKSPACES_VIEW                (cdos_workspaces_view_get_type ())
#define CDOS_WORKSPACES_VIEW(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_WORKSPACES_VIEW, CdosWorkspacesView))
#define CDOS_IS_WORKSPACES_VIEW(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_WORKSPACES_VIEW))
#define CDOS_WORKSPACES_VIEW_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_WORKSPACES_VIEW, CdosWorkspacesViewClass))
#define CDOS_IS_WORKSPACES_VIEW_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_WORKSPACES_VIEW))
#define CDOS_WORKSPACES_VIEW_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_WORKSPACES_VIEW, CdosWorkspacesViewClass))

typedef struct _CdosWorkspacesView              CdosWorkspacesView;
typedef struct _CdosWorkspacesViewPrivate       CdosWorkspacesViewPrivate;
typedef struct _CdosWorkspacesViewClass         CdosWorkspacesViewClass;

typedef struct _WindowSequenceMap
{
    guint stable_sequence;
    guint index;
}WindowSequenceMap;

struct _CdosWorkspacesView
{
  StGroup parent;

  CdosWorkspacesViewPrivate *priv;
};

struct _CdosWorkspacesViewClass
{
  StGroupClass parent_class;

  /* signals */
};

GType cdos_workspaces_view_get_type (void);

CdosWorkspacesView *
cdos_workspaces_view_new (void);

#endif /* __CDOS_WORKSPACES_VIEW_H__ */
